diff --git a/tests/unit/test-crypto-akcipher.c b/tests/unit/test-crypto-akcipher.c
index 4f1f4214dd..7b0f5ac4d4 100644
--- a/tests/unit/test-crypto-akcipher.c
+++ b/tests/unit/test-crypto-akcipher.c
@@ -314,6 +314,100 @@ static const uint8_t rsa2048_public_key[] = {
     0xed, 0x02, 0x03, 0x01, 0x00, 0x01
 };
 
+static const uint8_t ecdsa_p192_public_key[] = {
+    0x04, 0xc4, 0x16, 0xb3, 0xff, 0xac, 0xd5, 0x87,
+    0x98, 0xf7, 0xd9, 0x45, 0xfe, 0xd3, 0x5c, 0x17,
+    0x9d, 0xb2, 0x36, 0x22, 0xcc, 0x07, 0xb3, 0x6d,
+    0x3c, 0x4e, 0x04, 0x5f, 0xeb, 0xb6, 0x52, 0x58,
+    0xfb, 0x36, 0x10, 0x52, 0xb7, 0x01, 0x62, 0x0e,
+    0x94, 0x51, 0x1d, 0xe2, 0xef, 0x10, 0x82, 0x88,
+    0x78,
+};
+
+static const uint8_t ecdsa_p192_private_key[] = {
+    0x30, 0x53, 0x02, 0x01, 0x01, 0x04, 0x18, 0xcb,
+    0xc8, 0x86, 0x0e, 0x66, 0x3c, 0xf7, 0x5a, 0x44,
+    0x13, 0xb8, 0xef, 0xea, 0x1d, 0x7b, 0xa6, 0x1c,
+    0xda, 0xf4, 0x1b, 0xc7, 0x67, 0x6b, 0x35, 0xa1,
+    0x34, 0x03, 0x32, 0x00, 0x04, 0xc4, 0x16, 0xb3,
+    0xff, 0xac, 0xd5, 0x87, 0x98, 0xf7, 0xd9, 0x45,
+    0xfe, 0xd3, 0x5c, 0x17, 0x9d, 0xb2, 0x36, 0x22,
+    0xcc, 0x07, 0xb3, 0x6d, 0x3c, 0x4e, 0x04, 0x5f,
+    0xeb, 0xb6, 0x52, 0x58, 0xfb, 0x36, 0x10, 0x52,
+    0xb7, 0x01, 0x62, 0x0e, 0x94, 0x51, 0x1d, 0xe2,
+    0xef, 0x10, 0x82, 0x88, 0x78,
+};
+
+static const uint8_t ecdsa_p256_private_key[] = {
+    0x30, 0x77, 0x02, 0x01, 0x01, 0x04, 0x20, 0xf6,
+    0x92, 0xdd, 0x29, 0x1c, 0x6e, 0xef, 0xb6, 0xb2,
+    0x73, 0x9f, 0x40, 0x1b, 0xb3, 0x2a, 0x28, 0xd2,
+    0x37, 0xd6, 0x4a, 0x5b, 0xe4, 0x40, 0x4c, 0x6a,
+    0x95, 0x99, 0xfa, 0xf7, 0x92, 0x49, 0xbe, 0xa0,
+    0x0a, 0x06, 0x08, 0x2a, 0x86, 0x48, 0xce, 0x3d,
+    0x03, 0x01, 0x07, 0xa1, 0x44, 0x03, 0x42, 0x00,
+    0x04, 0xed, 0x42, 0x9c, 0x67, 0x79, 0xbe, 0x46,
+    0x83, 0x88, 0x3e, 0x8c, 0xc1, 0x33, 0xf3, 0xc3,
+    0xf6, 0x2c, 0xf3, 0x13, 0x6a, 0x00, 0xc2, 0xc9,
+    0x3e, 0x87, 0x7f, 0x86, 0x39, 0xe6, 0xae, 0xe3,
+    0xb9, 0xba, 0x2f, 0x58, 0x63, 0x32, 0x62, 0x62,
+    0x54, 0x07, 0x27, 0xf9, 0x5a, 0x3a, 0xc7, 0x3a,
+    0x6b, 0x5b, 0xbc, 0x0d, 0x33, 0xba, 0xbb, 0xd4,
+    0xa3, 0xff, 0x4f, 0x9e, 0xdd, 0xf5, 0x59, 0xc0,
+    0xf6,
+};
+
+static const uint8_t ecdsa_p256_public_key[] = {
+    0x04, 0xed, 0x42, 0x9c, 0x67, 0x79, 0xbe, 0x46,
+    0x83, 0x88, 0x3e, 0x8c, 0xc1, 0x33, 0xf3, 0xc3,
+    0xf6, 0x2c, 0xf3, 0x13, 0x6a, 0x00, 0xc2, 0xc9,
+    0x3e, 0x87, 0x7f, 0x86, 0x39, 0xe6, 0xae, 0xe3,
+    0xb9, 0xba, 0x2f, 0x58, 0x63, 0x32, 0x62, 0x62,
+    0x54, 0x07, 0x27, 0xf9, 0x5a, 0x3a, 0xc7, 0x3a,
+    0x6b, 0x5b, 0xbc, 0x0d, 0x33, 0xba, 0xbb, 0xd4,
+    0xa3, 0xff, 0x4f, 0x9e, 0xdd, 0xf5, 0x59, 0xc0,
+    0xf6,
+};
+
+static const uint8_t ecdsa_p384_public_key[] = {
+    0x04, 0xab, 0xd5, 0xf8, 0x87, 0x1d, 0x23, 0x9b,
+    0x26, 0xb9, 0x57, 0x7e, 0x97, 0x78, 0x10, 0xcd,
+    0x13, 0xe3, 0x98, 0x25, 0xa8, 0xd6, 0xab, 0x66,
+    0x35, 0x26, 0x68, 0x8a, 0x0e, 0x49, 0xd9, 0x4a,
+    0x91, 0x7d, 0x6c, 0x94, 0x06, 0x06, 0x99, 0xf1,
+    0x8d, 0x2a, 0x25, 0x8d, 0xf9, 0xbf, 0x40, 0xfa,
+    0xb7, 0xcb, 0xe1, 0x14, 0x22, 0x0a, 0xa7, 0xfb,
+    0x0a, 0xb4, 0x02, 0x05, 0x8b, 0x98, 0xaa, 0x78,
+    0xcd, 0x53, 0x00, 0x1e, 0xd1, 0x79, 0x6a, 0x5f,
+    0x09, 0x01, 0x88, 0xb4, 0xbc, 0x32, 0x62, 0x83,
+    0x92, 0x84, 0x2d, 0xc6, 0xf8, 0xda, 0xc4, 0x7f,
+    0x10, 0xa3, 0x18, 0x1d, 0xae, 0x0d, 0xa4, 0x41,
+    0x9f,
+};
+
+static const uint8_t ecdsa_p384_private_key[] = {
+    0x30, 0x81, 0x9b, 0x02, 0x01, 0x01, 0x04, 0x30,
+    0xb6, 0x04, 0xef, 0xb1, 0x2c, 0x98, 0xdf, 0xcf,
+    0xd4, 0x16, 0x31, 0xd4, 0x69, 0x0c, 0x27, 0x81,
+    0x4a, 0xac, 0x1a, 0x83, 0x3c, 0xe4, 0xef, 0x65,
+    0xe1, 0x7a, 0x6a, 0xc6, 0xd6, 0xf7, 0xea, 0x79,
+    0xbe, 0xf1, 0x00, 0x3c, 0xdf, 0x6e, 0x9d, 0x10,
+    0x22, 0x61, 0x1b, 0x11, 0xcf, 0x49, 0x6e, 0x62,
+    0xa1, 0x64, 0x03, 0x62, 0x00, 0x04, 0xab, 0xd5,
+    0xf8, 0x87, 0x1d, 0x23, 0x9b, 0x26, 0xb9, 0x57,
+    0x7e, 0x97, 0x78, 0x10, 0xcd, 0x13, 0xe3, 0x98,
+    0x25, 0xa8, 0xd6, 0xab, 0x66, 0x35, 0x26, 0x68,
+    0x8a, 0x0e, 0x49, 0xd9, 0x4a, 0x91, 0x7d, 0x6c,
+    0x94, 0x06, 0x06, 0x99, 0xf1, 0x8d, 0x2a, 0x25,
+    0x8d, 0xf9, 0xbf, 0x40, 0xfa, 0xb7, 0xcb, 0xe1,
+    0x14, 0x22, 0x0a, 0xa7, 0xfb, 0x0a, 0xb4, 0x02,
+    0x05, 0x8b, 0x98, 0xaa, 0x78, 0xcd, 0x53, 0x00,
+    0x1e, 0xd1, 0x79, 0x6a, 0x5f, 0x09, 0x01, 0x88,
+    0xb4, 0xbc, 0x32, 0x62, 0x83, 0x92, 0x84, 0x2d,
+    0xc6, 0xf8, 0xda, 0xc4, 0x7f, 0x10, 0xa3, 0x18,
+    0x1d, 0xae, 0x0d, 0xa4, 0x41, 0x9f,
+};
+
 static const uint8_t test_sha1_dgst[] = {
     0x3c, 0x05, 0x19, 0x34, 0x29, 0x19, 0xc7, 0xe0,
     0x87, 0xb6, 0x24, 0xf9, 0x58, 0xac, 0xa4, 0xd4,
@@ -374,6 +468,45 @@ static const uint8_t exp_signature_rsa1024_pkcs1[] = {
     0xab, 0x0d, 0xc6, 0x59, 0x1d, 0xc7, 0x33, 0x7b,
 };
 
+static const uint8_t exp_signature_ecdsa_p192[] = {
+    0x30, 0x35, 0x02, 0x19, 0x00, 0xba, 0xf7, 0xc0,
+    0xc1, 0x7e, 0xf5, 0x69, 0xd5, 0xb7, 0x5d, 0x06,
+    0xcb, 0x92, 0x28, 0x57, 0x52, 0x96, 0x9a, 0xdc,
+    0xc9, 0xf9, 0xd5, 0x2c, 0x51, 0x02, 0x18, 0x26,
+    0x21, 0x5d, 0x16, 0xba, 0xff, 0x19, 0x74, 0x56,
+    0x8e, 0xdf, 0x51, 0x2b, 0x2c, 0xce, 0xc2, 0x7b,
+    0x5b, 0x03, 0x10, 0x56, 0x57, 0x63, 0x47,
+};
+
+static const uint8_t exp_signature_ecdsa_p256[] = {
+    0x30, 0x45, 0x02, 0x21, 0x00, 0xac, 0x09, 0xf3,
+    0x32, 0xb6, 0xf6, 0x7e, 0x12, 0x4f, 0x68, 0xdb,
+    0x10, 0x14, 0x61, 0xf6, 0x29, 0xbd, 0xdd, 0x72,
+    0x9f, 0x81, 0xf8, 0x83, 0x8a, 0xf3, 0x29, 0x87,
+    0x7b, 0xbb, 0xcf, 0xea, 0x64, 0x02, 0x20, 0x14,
+    0xfc, 0x2e, 0x2f, 0x3e, 0x06, 0xb1, 0xd0, 0xbb,
+    0x91, 0x44, 0xd5, 0x53, 0xb4, 0x72, 0xa1, 0x83,
+    0xc7, 0x3a, 0xa8, 0xfc, 0x43, 0x1b, 0x2e, 0xbb,
+    0xb0, 0xe9, 0xef, 0x0b, 0x03, 0x32, 0x74,
+};
+
+static const uint8_t exp_signature_ecdsa_p384[] = {
+    0x30, 0x64, 0x02, 0x30, 0x3c, 0x79, 0x7f, 0x5a,
+    0x91, 0x08, 0x79, 0xde, 0x6e, 0x03, 0x19, 0x39,
+    0xcb, 0x94, 0x9c, 0xc6, 0x09, 0x12, 0xfa, 0xbd,
+    0xa8, 0x35, 0x5e, 0x3f, 0x74, 0x05, 0x12, 0xd1,
+    0x8e, 0xd9, 0x3c, 0x79, 0x9d, 0x7c, 0x1a, 0xae,
+    0x96, 0x05, 0x0e, 0x35, 0x21, 0x73, 0xd8, 0xfe,
+    0x1b, 0x43, 0x06, 0xb9, 0x02, 0x30, 0x11, 0xdf,
+    0xa7, 0xba, 0x70, 0x84, 0x4b, 0x74, 0xab, 0x1e,
+    0x9e, 0x6a, 0xc1, 0x46, 0xe3, 0x98, 0x0a, 0x25,
+    0x82, 0xf5, 0xff, 0xb5, 0x6f, 0x04, 0xda, 0xc3,
+    0xfd, 0x3e, 0xea, 0x96, 0x03, 0x0c, 0x22, 0xf2,
+    0xda, 0x86, 0xeb, 0x91, 0x2f, 0x36, 0x13, 0xba,
+    0x37, 0xcd, 0xe7, 0x91, 0x85, 0xf3,
+};
+
+
 static const uint8_t test_plaintext[] = {
     0x00, 0x44, 0xbc, 0x6f, 0x77, 0xfb, 0xe2, 0xa4,
     0x98, 0x9e, 0xf5, 0x33, 0xa0, 0xbd, 0x81, 0xb9,
@@ -870,7 +1003,60 @@ static QCryptoAkCipherTestData akcipher_test_data[] = {
         .signature = exp_signature_rsa2048_pkcs1,
         .slen = sizeof(exp_signature_rsa2048_pkcs1),
     },
+    {
+        .path = "/crypto/akcipher/ecdsa-nist-p192",
+        .opt = {
+            .alg = QCRYPTO_AKCIPHER_ALG_ECDSA,
+            .u.ecdsa = {
+                .curve_id = QCRYPTO_CURVE_ID_NIST_P192,
+            },
+        },
+        .pub_key = ecdsa_p192_public_key,
+        .pub_key_len = sizeof(ecdsa_p192_public_key),
+        .priv_key = ecdsa_p192_private_key,
+        .priv_key_len = sizeof(ecdsa_p192_private_key),
 
+        .dgst = test_sha1_dgst,
+        .dlen = sizeof(test_sha1_dgst),
+        .signature = exp_signature_ecdsa_p192,
+        .slen = sizeof(exp_signature_ecdsa_p192),
+    },
+    {
+        .path = "/crypto/akcipher/ecdsa-nist-p256",
+        .opt = {
+            .alg = QCRYPTO_AKCIPHER_ALG_ECDSA,
+            .u.ecdsa = {
+                .curve_id = QCRYPTO_CURVE_ID_NIST_P256,
+            },
+        },
+        .pub_key = ecdsa_p256_public_key,
+        .pub_key_len = sizeof(ecdsa_p256_public_key),
+        .priv_key = ecdsa_p256_private_key,
+        .priv_key_len = sizeof(ecdsa_p256_private_key),
+
+        .dgst = test_sha1_dgst,
+        .dlen = sizeof(test_sha1_dgst),
+        .signature = exp_signature_ecdsa_p256,
+        .slen = sizeof(exp_signature_ecdsa_p256),
+    },
+    {
+        .path = "/crypto/akcipher/ecdsa-nist-p384",
+        .opt = {
+            .alg = QCRYPTO_AKCIPHER_ALG_ECDSA,
+            .u.ecdsa = {
+                .curve_id = QCRYPTO_CURVE_ID_NIST_P384,
+            },
+        },
+        .pub_key = ecdsa_p384_public_key,
+        .pub_key_len = sizeof(ecdsa_p384_public_key),
+        .priv_key = ecdsa_p384_private_key,
+        .priv_key_len = sizeof(ecdsa_p384_private_key),
+
+        .dgst = test_sha1_dgst,
+        .dlen = sizeof(test_sha1_dgst),
+        .signature = exp_signature_ecdsa_p384,
+        .slen = sizeof(exp_signature_ecdsa_p384),
+    },
 };
 
 static void test_akcipher(const void *opaque)
@@ -879,6 +1065,8 @@ static void test_akcipher(const void *opaque)
     g_autofree uint8_t *plaintext = NULL;
     g_autofree uint8_t *ciphertext = NULL;
     g_autofree uint8_t *signature = NULL;
+    int signature_len, ciphertext_len, plaintext_len;
+    int max_plen, max_slen, max_clen;
     QCryptoAkCipher *pub_key, *priv_key;
 
     if (!qcrypto_akcipher_supports((QCryptoAkCipherOptions *)&data->opt)) {
@@ -894,32 +1082,41 @@ static void test_akcipher(const void *opaque)
                                     data->priv_key, data->priv_key_len,
                                     &error_abort);
     g_assert(priv_key != NULL);
+    max_plen = qcrypto_akcipher_max_plaintext_len(pub_key);
+    max_clen = qcrypto_akcipher_max_plaintext_len(pub_key);
+    max_slen = qcrypto_akcipher_max_signature_len(priv_key);
 
     if (data->plaintext != NULL) {
 
-        ciphertext = g_new0(uint8_t, data->clen);
-        g_assert(qcrypto_akcipher_encrypt(pub_key, data->plaintext, data->plen,
-                                          ciphertext, data->clen,
-                                          &error_abort) > 0);
+        ciphertext = g_new0(uint8_t, max_clen);
+        ciphertext_len = qcrypto_akcipher_encrypt(pub_key,
+                                                  data->plaintext, data->plen,
+                                                  ciphertext, max_clen,
+                                                  &error_abort);
+        g_assert(ciphertext_len > 0);
 
         /**
          * In the asymmetric encryption algorithms, the ciphertext generated
          * each time may be different, here only compare the decrypted
          * plaintext
          */
-        plaintext = g_new0(uint8_t, data->clen);
-        g_assert(qcrypto_akcipher_decrypt(priv_key, ciphertext,
-                                          data->clen, plaintext,
-                                          data->plen,
-                                          &error_abort) == data->plen);
+        plaintext = g_new0(uint8_t, max_plen);
+        plaintext_len = qcrypto_akcipher_decrypt(priv_key,
+                                                 ciphertext, ciphertext_len,
+                                                 plaintext, max_plen,
+                                                 &error_abort);
+        g_assert(plaintext_len == data->plen);
         g_assert(!memcmp(plaintext, data->plaintext, data->plen));
     }
 
     if (data->signature != NULL) {
-        signature = g_new(uint8_t, data->slen);
-        g_assert(qcrypto_akcipher_sign(priv_key, data->dgst, data->dlen,
-                                       signature, data->slen,
-                                       &error_abort) > 0);
+        signature = g_new(uint8_t, max_slen);
+        signature_len = qcrypto_akcipher_sign(priv_key,
+                                              data->dgst, data->dlen,
+                                              signature, max_slen,
+                                              &error_abort);
+        g_assert(signature_len > 0);
+
         /**
          * The signature generated each time may be different, here only check
          * the verification.
@@ -927,12 +1124,12 @@ static void test_akcipher(const void *opaque)
         g_assert(qcrypto_akcipher_verify(pub_key, data->signature, data->slen,
                                          data->dgst, data->dlen,
                                          &error_abort) == 0);
-        g_assert(qcrypto_akcipher_verify(pub_key, signature, data->slen,
+        g_assert(qcrypto_akcipher_verify(pub_key, signature, signature_len,
                                          data->dgst, data->dlen,
                                          &error_abort) == 0);
         ++signature[0];
         /* Here error should be ignored */
-        g_assert(qcrypto_akcipher_verify(pub_key, signature, data->slen,
+        g_assert(qcrypto_akcipher_verify(pub_key, signature, signature_len,
                                          data->dgst, data->dlen, NULL) != 0);
     }
 